/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name$
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/
package net.sf.jguard.ext.authentication;

import java.security.Permission;
import java.security.Permissions;
import java.util.Collection;

import net.sf.jguard.core.authentication.AuthenticationBindings;
import net.sf.jguard.core.authorization.AuthorizationBindings;


public abstract class AbstractAuthenticationBindings implements AuthenticationBindings {

    protected Permission logonProcessPermission;
    protected Permission logoffPermission;
    protected Permission indexPermission;
    protected static Permission logonPermission;
    protected Permission authenticationFailedPermission = null;
    
    protected AuthorizationBindings authZbindings = null;
    
    protected boolean goToLastAccessDeniedUriOnSuccess;
    protected Collection authSchemes;
    protected String authScheme = null;
    
    public AbstractAuthenticationBindings(AuthorizationBindings authorizationBindings){
    	super();
    	this.authZbindings = authorizationBindings;
    }
    
	public Permissions getGrantedPermissions() {
		
		Permissions alwaysGrantedPermissions = new Permissions();
		alwaysGrantedPermissions.add(getAuthenticationFailedPermission());
		alwaysGrantedPermissions.add(getLogonProcessPermission());
		alwaysGrantedPermissions .add(getLogonPermission());
		alwaysGrantedPermissions .add(getIndexPermission());
		alwaysGrantedPermissions .add(getLogoffPermission());
		return alwaysGrantedPermissions;
	}
	
	 public Permission getAuthenticationFailedPermission() {
	        return authenticationFailedPermission;
	 }

	 public Permission getLogonPermission() {
	        return logonPermission;
	 }

	 public Permission getLogonProcessPermission() {
	        return logonProcessPermission;
	 }
	    
	 public Permission getIndexPermission() {
	        return indexPermission;
	 }

	 public Permission getLogoffPermission() {
	        return logoffPermission;
	 }
	 
	 public Collection getAuthSchemes() {
			return authSchemes;
	 }		
}
