/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name:  $
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/
package net.sf.jguard.ext.authentication.callbacks;

import java.io.IOException;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;

/**
 * @author <a href="mailto:diabolo512@users.sourceforge.net ">Charles Gay</a>
 * @author <a href="mailto:vberetti@users.sourceforge.net">Vincent Beretti</a>
 */
public class JMXCallbackHandler implements CallbackHandler {
	
	private String[] credentials = null;
	
	
	public JMXCallbackHandler(Object credentials){
		this.credentials = (String[])credentials;
	}
	
	public void handle(Callback[] callbacks) throws IOException,
	UnsupportedCallbackException {
		for (int i = 0; i < callbacks.length; i++){
			Callback c = callbacks[i];
			if (c instanceof NameCallback){
				((NameCallback)c).setName(credentials[0]);
			}else if (c instanceof PasswordCallback){
				((PasswordCallback)c).setPassword((credentials[1]).toCharArray());
			}else if (c instanceof JCaptchaCallback){
				JCaptchaCallback jc = (JCaptchaCallback)c;
				//we skip JCaptcha because we cannot provide 
				//CAPTCHA challenge through JMX
				jc.setSkipJCaptchaChallenge(true);
			}
		}
	}
}
