package net.sf.jguard.ext.authentication.manager;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Map;

import net.sf.jguard.core.authentication.manager.AuthenticationManager;

public class AuthenticationManagerUtils {

	
	public static String exportAsXMLString(AuthenticationManager authenticationManager,Map authenticationManagerOptions){
    	XmlAuthenticationManager xmlAuthenticationManager = exportAsXmlAuthenticationManager(authenticationManager,authenticationManagerOptions);
    	return xmlAuthenticationManager.exportAsXMLString();
    }
	
    /**
     * return a <strong>new</strong> XmlAuthenticationManager although if the parameter is already an XmlAuthenticationManager.
     * @param authenticationManager
     * @return
     */
	public static XmlAuthenticationManager exportAsXmlAuthenticationManager(AuthenticationManager authenticationManager,Map authenticationManagerOptions) {
		XmlAuthenticationManager xmlAuthenticationManager = null;
   		xmlAuthenticationManager = new XmlAuthenticationManager(authenticationManagerOptions);
   		xmlAuthenticationManager.importAuthenticationManager(authenticationManager);
    	
		return xmlAuthenticationManager;
	}
	
	public static void writeAsHTML(AuthenticationManager authenticationManager,Map authenticationManagerOptions,OutputStream outputStream) throws IOException{
	    	XmlAuthenticationManager xmlAuthenticationManager = exportAsXmlAuthenticationManager(authenticationManager,authenticationManagerOptions);
	    	xmlAuthenticationManager.writeAsHTML(outputStream);
	}
	    
	public static void writeAsXML(AuthenticationManager authenticationManager,Map authenticationManagerOptions,OutputStream outputStream,String encodingScheme) throws IOException{
	    	XmlAuthenticationManager xmlAuthenticationManager = exportAsXmlAuthenticationManager(authenticationManager,authenticationManagerOptions);
	    	xmlAuthenticationManager.writeAsXML(outputStream, encodingScheme);
	}
	    
	public static void exportAsXMLFile(AuthenticationManager authenticationManager,Map authenticationManagerOptions,String fileName) throws IOException{
	    	XmlAuthenticationManager xmlAuthenticationManager = exportAsXmlAuthenticationManager(authenticationManager,authenticationManagerOptions);
	    	xmlAuthenticationManager.exportAsXMLFile(fileName);
	}
	
	
}
